service_1_compression/compression/urls.py
from django.conf.urls import url
from django.views.generic.base import RedirectView
from .views import *
#url for app
app_name = 'compression'

urlpatterns = [
	url(r'^$', RedirectView.as_view(url='compress/', permanent = False), name='$'),
    url(r'compress/', compress, name='compress'),
    url(r'auth_login/', auth_login, name='auth_login'),
]

service_1_compression/service_1_compression/urls.py
from django.contrib import admin
from django.urls import path, include
import compression.urls as compression

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include(compression, namespace='compression')),
]

service_1_compression/compression/models.py
from django.db import models

# Create your models here.

service_1_compression/compression/forms.py
from django import forms

class FileForm(forms.Form):
    file = forms.FileField() # for creating file input  

service_1_compression/compression/views.py
from django.http import FileResponse
from django.shortcuts import render
from .auth_utils import ambil_token, ambil_resource
from .forms import FileForm

import tempfile, zipfile, os

def compress(request):
    response = {}
    if not request.session.get('access_token'):
        return render(request, 'login.html', response)
    resp = ambil_resource(request.session.get('access_token'))
    json_response = resp.json()
    if 'error' in json_response:
        response['expired'] = "expired"
        return render(request, 'login.html', response)
    if request.POST:
        fileForm = FileForm(request.POST, request.FILES)
        if fileForm.is_valid:
            file = request.FILES['file']
            fileName = request.FILES['file'].name
            handle_uploaded_file(request.FILES['file'], fileName)
            with zipfile.ZipFile('zipped_file.zip', 'w') as myzip:
                myzip.write(fileName)
            myzip.close()
            os.remove(fileName)
            zip_file = open('zipped_file.zip', 'rb')
            return FileResponse(zip_file)
        else:
            response['error'] = "error"
    fileForm = FileForm()
    response['form'] = fileForm
    return render(request, 'compress.html', response)

def handle_uploaded_file(f, name):
    with open(name, 'wb+') as destination:
        for chunk in f.chunks():
            destination.write(chunk)

def auth_login(request):
    response = {}
    if request.POST:
        username = request.POST['username']
        password = request.POST['password']
        resp = ambil_token(username, password, 'oSheev1Woh0OhFieza5ud1ahm9xooNgiuxaefaok', 'Tiongoh1phi0hithai6meiz4aj5roo8Boh0eeb6a')
        json_response = resp.json()
        if 'error' in json_response:
            response['error'] = "error"
            return render(request, 'login.html', response)
        access_token = json_response['access_token']
        request.session['access_token'] = access_token
        fileForm = FileForm()
        response['form'] = fileForm
        return render(request, 'compress.html', response)

service_1_compression/templates/base.html
{% load static %}
<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="theme-color" content="#342345">
  <title> {% block title %} Service 1 of LAW_KEMAS {% endblock %}</title>
  <link rel="icon" type="image/png" href="{% static 'images/favicon/bis.png' %}">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css" type="text/css">
  <link href='https://fonts.googleapis.com/css?family=Raleway:900|Raleway' rel='stylesheet'>
  <meta name="viewport" content="initial-scale=1.0, width=device-width" />

  {% block css %}
      
  {% endblock %}
</head>

<body>
  <div class="se-pre-con"></div>
  <header>
  <!-- navbar -->
  {% block header %}
  {% endblock %}
</header>
<content>
  <!-- content -->

    {% block content %}
    {% endblock %}
 
</content>
<footer>
  {% block footer %}
  {% endblock %}
</footer>

  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js"></script>
  {% block javascript %}
  {% endblock %}
</body>

</html>

service_1_compression/templates/compress.html
{% extends "base.html" %}
{% load static %}
{% block css %}
{% endblock %}

{% block content %}
<section name="container" class="content">
  <h2>File Compression</h2>
  <form id="form" name="form" method="POST" action="{% url 'compression:compress' %}" enctype="multipart/form-data">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Submit</button>
  </form>

  {% if error %}
    <h3>TERDAPAT ERROR PROCESSING FILE</h3>
  {% else %}
  {% endif %}

</section>
{% endblock %}

{% block javascript %}
{% endblock %}

service_1_compression/templates/login.html
{% extends "base.html" %}
{% load static %}
{% block css %}
{% endblock %}

{% block content %}
<section name="container" class="content">
  <h2>LOG IN</h2>
  <form id="form" name="form" method="POST" action="{% url 'compression:auth_login' %}" enctype="multipart/form-data">
    {% csrf_token %}
    <input type="text" name="username" placeholder="username">
    <input type="password" name="password" placeholder="password">
    <button type="submit">Submit</button>
  </form>

  {% if error %}
    <h3>Wrong username or password</h3>
  {% elif expired %}
    <h3>Session has expired, please login again</h3>
  {% endif %}

</section>
{% endblock %}

{% block javascript %}
{% endblock %}